#!/bin/sh
#
# Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
# (Royal Institute of Technology, Stockholm, Sweden). 
# All rights reserved. 
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met: 
#
# 1. Redistributions of source code must retain the above copyright 
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright 
#    notice, this list of conditions and the following disclaimer in the 
#    documentation and/or other materials provided with the distribution. 
#
# 3. Neither the name of the Institute nor the names of its contributors 
#    may be used to endorse or promote products derived from this software 
#    without specific prior written permission. 
#
# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
# ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
# SUCH DAMAGE. 
#
# $Id$
#

srcdir="@srcdir@"
env_setup="@env_setup@"
objdir="@objdir@"
EGREP="@EGREP@"

. ${env_setup}

testfailed="echo test failed; cat messages.log; exit 1"

# If there is no useful db support compiled in, disable test
../db/have-db || exit 77

R=TEST.H5L.SE
R2=TEST2.H5L.SE

port=@port@

kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r ${R}"
kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"

server=host/datan.test.h5l.se
cache="FILE:${objdir}/cache.krb5"
keytabfile=${objdir}/server.keytab
keytab="FILE:${keytabfile}"
rodc_kvno="3058761729"

kinit="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache ${afs_no_afslog}"
klist="${TESTS_ENVIRONMENT} ../../kuser/klist -c $cache"
kgetcred="${TESTS_ENVIRONMENT} ../../kuser/kgetcred -c $cache"
kdestroy="${TESTS_ENVIRONMENT} ../../kuser/kdestroy -c $cache ${afs_no_unlog}"
test_apreq="${TESTS_ENVIRONMENT} ../../lib/krb5/test_ap-req"

KRB5_CONFIG="${objdir}/krb5.conf"
export KRB5_CONFIG

rm -f ${keytabfile}
rm -f current-db*
rm -f out-*
rm -f mkey.file*

> messages.log

echo Creating database
${kadmin} \
    init \
    --realm-max-ticket-life=1day \
    --realm-max-renewable-life=1month \
    ${R} || exit 1

${kadmin} add -p foo --use-defaults foo@${R} || exit 1
${kadmin} add -p bar --use-defaults ${server}@${R} || exit 1
${kadmin} modify --kvno=$rodc_kvno "krbtgt/${R}@${R}" || exit 1
${kadmin} ext -k ${keytab} ${server}@${R} || exit 1

${kadmin} \
    init \
    --realm-max-ticket-life=1day \
    --realm-max-renewable-life=1month \
    ${R2} || exit 1

${kadmin} add -p foo --use-defaults foo@${R2} || exit 1
${kadmin} add -p bar --use-defaults bar@${R2} || exit 1
${kadmin} ext -k ${keytab} bar@${R2} || exit 1

echo "Doing database check"
${kadmin} check ${R} || exit 1
${kadmin} check ${R2} || exit 1

echo foo > ${objdir}/foopassword

echo "Empty log"
> messages.log

echo Starting kdc
${kdc} --detach --testing || { echo "kdc failed to start"; cat messages.log; exit 1; }
kdcpid=`getpid kdc`

cleanup() {
    echo signal killing kdc
    kill -9 ${kdcpid}
    trap '' EXIT INT TERM
    cat messages.log
    exit 1
}
trap cleanup EXIT INT TERM

ec=0

echo "Check that KDC plugin module was loaded "
grep "kdc plugin init" messages.log >/dev/null || \
	{ ec=1 ; eval "${testfailed}"; }

echo "Getting client initial tickets"; > messages.log
${kinit} --password-file=${objdir}/foopassword foo@${R} || \
	{ ec=1 ; eval "${testfailed}"; }
echo "Getting tickets" ; > messages.log
${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
echo "Verify PAC on server"; > messages.log
${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} || \
	{ ec=1 ; eval "${testfailed}"; }
${kdestroy}

echo "Getting client initial tickets (pac)"; > messages.log
${kinit} --request-pac --password-file=${objdir}/foopassword foo@${R} || \
	{ ec=1 ; eval "${testfailed}"; }
echo "Getting tickets" ; > messages.log
${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
echo "Verify PAC on server (pac)"; > messages.log
${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} || \
	{ ec=1 ; eval "${testfailed}"; }
${kdestroy}

echo "Getting client initial tickets (no pac)"; > messages.log
${kinit} --no-request-pac --password-file=${objdir}/foopassword foo@${R} || \
	{ ec=1 ; eval "${testfailed}"; }
echo "Getting tickets" ; > messages.log
${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
echo "Verify PAC on server (no pac)"; > messages.log
${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} 2> /dev/null && \
	{ ec=1 ; eval "${testfailed}"; }
${test_apreq} ${server}@${R} ${keytab} ${cache} 2> /dev/null && \
	{ ec=1 ; eval "${testfailed}"; }
echo "Check the --no-verify-pac option"; > messages.log
${test_apreq} --no-verify-pac ${server}@${R} ${keytab} ${cache} 2> /dev/null || \
	{ ec=1 ; eval "${testfailed}"; }
${kdestroy}

echo "Getting client initial tickets (no pac - realm config)"; > messages.log
${kinit} --no-request-pac --password-file=${objdir}/foopassword foo@${R2} || \
	{ ec=1 ; eval "${testfailed}"; }
echo "Getting tickets" ; > messages.log
${kgetcred} bar@${R2} || { ec=1 ; eval "${testfailed}"; }
echo "Verify PAC on server (no pac - realm config)"; > messages.log
${test_apreq} --verify-pac bar@${R2} ${keytab} ${cache} 2> /dev/null && \
	{ ec=1 ; eval "${testfailed}"; }
${test_apreq} bar@${R2} ${keytab} ${cache} 2> /dev/null && \
	{ ec=1 ; eval "${testfailed}"; }


echo "killing kdc (${kdcpid})"
kill $kdcpid || exit 1

trap "" EXIT

exit $ec
